﻿namespace ControllerPropertyInjectTestWebApp.Controllers
{
    using System;

    using Microsoft.AspNetCore.Mvc;
    using Microsoft.Extensions.DependencyInjection;
    using Microsoft.Extensions.Logging;

    [ApiController]
    [Route("api/[controller]")]
    public class TestBaseController : ControllerBase, IServiceProviderSetter
    {
        //logger只是个示例，仅在使用时才创建，实际还可以直接获取，或者使用Lazy<T>等各种操作。其它属性同理。
        private ILogger _logger;
        private IServiceProvider _serviceProvider;

        protected ILogger Logger
        {
            get
            {
                if (_logger != null)
                {
                    return _logger;
                }
                _logger = _serviceProvider.GetRequiredService<ILoggerFactory>().CreateLogger(GetType());
                return _logger;
            }
        }

        [NonAction]
        public void SetServiceProvider(IServiceProvider serviceProvider)
        {
            _serviceProvider = serviceProvider;
        }
    }
}
